/****************************************************************************
**
** Copyright (C) 2016 The Qt Company Ltd.
** Contact: https://www.qt.io/licensing/
** Copyright (C) 2019 Rémi Ducceschi
**
** This file is part of the QLALR module of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:GPL-EXCEPT$
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The Qt Company. For licensing terms
** and conditions see https://www.qt.io/terms-conditions. For further
** information use the contact form at https://www.qt.io/contact-us.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 3 as published by the Free Software
** Foundation with exceptions as appearing in the file LICENSE.GPL3-EXCEPT
** included in the packaging of this file. Please review the following
** information to ensure the GNU General Public License requirements will
** be met: https://www.gnu.org/licenses/gpl-3.0.html.
**
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef LEXERPARSER_HPP
#define LEXERPARSER_HPP

#include <exception>
#include <iterator>
#include <unordered_set>
#include <vector>

#include <QString>

#include <ShareablePoints/SPIOException.hpp>

#include "PluginsGlobal.hpp"
#include "ShareablePointsListIOLexer.hpp"
#include "TextUtils.hpp"

class QsciScintilla;

/**
 * Structure for a state during the parsing.
 */
struct State
{
	/** Action associated to this state. */
	int act = 0;
	/** Token parsed. */
	int token = -1;
	/** String representation of the parsed token. */
	QStringRef parsed;
};

/**
 * Abstract class for ShareablePointLists lexers that use QLALR.
 *
 * QLALR is a compiler compiler (like YACC/Bison) created by Qt that generates C++ code.
 * It can be used for complex lexers that need to understand a complex syntax.
 *
 * This class offers some convenient way to implement a lexer with a QLALR grammar. In order
 * to make it work correctly, you need at least to implement, on top of the pure virtual methods
 * from ShareablePointsListIOLexer, these 2 methods:
 * - virtual int nextToken(QStringRef value)
 * - virtual void consumeRule(int rule)
 *
 * You also need to include in your grammar a token called `EOL_SYMBOL`. Indeed, as all SUSoft
 * programs read input text files where the main delimiter is the new line character (`'\n'`),
 * this class mainly works with lines and expect this symbol to exist.
 *
 * For the input text to comply with the QLALR grammar it has to match the rules completly, i.e. it cannot start from the
 * middle rules or leaves, the text has to be fully consumed by the top-most rule. Therefore, lexer analyzes the entire
 * text each time to achieve the styling and it is impossible to analyze just some part of contents.
 *
 * ## QLALR grammar file example
 * Below is an example of a grammar file that you can use with this class. You can note 3 important
 * things:
 * 1. the way to inherit LexerParser with the template parameter `<$table>`
 * 2. the token `EOL_SYMBOL`
 * 3. the implementation is splitted in 2 *.cpp* files:
 *		- *example-gen.cpp* which is the file automatically created by QLALR. You only have stuff related to the grammar here
 *		- *example-impl.cpp* where you can write all the code related to ShareablePointsListIOLexer
 *
 * @code{cpp}
-- file "example.g"
-- This is a non-tested and non-complete example that is supposed to read stuff like "1+1-2"
%parser Table
%decl example.hpp
%impl example_gen.cpp

-- BASIC TOKENS
%token EOL_SYMBOL "New line '\\n'" -- VERY IMPORTANT ONE!!!
%token UNKNOWN "Unknown" -- unrecognized token
%token INTEGER "Integer number"
%token PLUS "+"
%token MINUS "-"

-- STARTING POINT
%start Start

-- example.hpp

/:
// /!\ This file is automatically generated by QLALR from example.g.
// /!\ Don't edit it!

#ifndef EXAMPLE_HPP
#define EXAMPLE_HPP

#include <editors/text/LexerParser.hpp>

#include "$header"

class Example : public LexerParser<$table>
{
	Q_OBJECT

public:
	Example(QObject* parent = nullptr) : LexerParser(parent) {}
	virtual ~Example() override = default;

	// QsciLexerCustom
	enum Styles
	{
		Integer,
		Sign
	};
	// implemented in example_impl.cpp
	virtual const char* language() const override { return "example"; }
	virtual const char* keywords(int set) const override;
	virtual QString description(int style) const override;
	virtual const char* wordCharacters() const override;
	virtual bool defaultEolFill(int style) const override;
	QColor defaultColor(int style) const override;
	QFont defaultFont(int style) const override;
	QColor defaultPaper(int style) const override;

	// IShareablePointsListIO
	// implemented in example_impl.cpp
	virtual const std::string& getMIMEType() const override;
	virtual ShareablePointsList read(const std::string& contents) override;
	virtual ShareableExtraInfos readExtraInfos(const std::string& contents) override;
	virtual ShareableFrame readFrame(const std::string& contents) override;
	virtual ShareableParams readParams(const std::string& contents) override;
	virtual ShareablePoint readPoint(const std::string& contents) override;
	virtual ShareablePosition readPosition(const std::string& contents) override;
	virtual std::string write(const ShareablePointsList& list) override;
	virtual std::string write(const ShareableExtraInfos&) override { return std::string(); }
	virtual std::string write(const ShareableFrame& frame) override;
	virtual std::string write(const ShareableParams& params) override;
	virtual std::string write(const ShareablePoint& point) override;
	virtual std::string write(const ShareablePosition& position) override;

private:
	// LexerParser
	// generated in in example_gen.cpp
	int nextToken(QStringRef value) override;
	void consumeRule(int ruleno) override;

private:
	int _result = 0;
};

#endif // EXAMPLE_HPP
: /

-- example_gen.cpp

/.
// /!\ This file is automatically generated by QLALR from example.g.
// /!\ Don't edit it!

#include "example.hpp"

void Example::consumeRule(int rule)
{
	switch (rule)
	{
		. /

----------------------------------------------------------- RULES

Start: Expressions EOL; -- must finish by one or more end of line

EOL: EOL_SYMBOL
	| EOL EOL_SYMBOL;

Expressions: Expression
	| Expressions Expression
	| Expressions Expression;

Expression: INTEGER
/.
	case $rule_number:
		addStyleSym(Styles::Integer, 1);
		_result = sym(1);
		break;
./
	| INTEGER PLUS INTEGER
/.
	case $rule_number:
		addStyleSym(Styles::Integer, 1);
		addStyleSym(Styles::Sign, 2);
		addStyleSym(Styles::Integer, 3);
		_result = sym(1) + sym(3);
		break;
./
	| INTEGER MINUS INTEGER;
/.
	case $rule_number:
		addStyleSym(Styles::Integer, 1);
		addStyleSym(Styles::Sign, 2);
		addStyleSym(Styles::Integer, 3);
		_result = sym(1) - sym(3);
		break;
./

----------------------------------------------------------- ENDRULES

/.
	} // of the switch
}

int Example::nextToken(QStringRef value)
{
	QStringRef tval = value.trimmed();
	if (!tval.isEmpty())
	{
		// PLUS
		if (tval == "+")
			return Example::PLUS;
		// MINUS
		if (tval == "-")
			return Example::MINUS;
		// INTEGER
		bool ok = false;
		tval.toInt(&ok);
		return ok ? Example::INTEGER : Example::UNKNOWN;
	}

	return Example::UNKNOWN;
}

 * @endcode
 */
template<class _Table>
class LexerParser : public ShareablePointsListIOLexer, protected _Table
{
	// Q_OBJECT // can't use it because the class is templated

public:
	LexerParser(QObject *parent = nullptr) : ShareablePointsListIOLexer(parent), _Table() {}
	virtual ~LexerParser() override = default;
	LexerParser(const LexerParser &) = delete;
	LexerParser(const LexerParser &&) = delete;
	LexerParser &operator=(const LexerParser &) = delete;
	LexerParser &operator=(const LexerParser &&) = delete;

	// TextLexer
	virtual void styleText(int start, int end) override;

	// LexerParser
	/** Starts the parsing of the whole text */
	virtual void parse();

protected:
	// TextLexer
	virtual void styleText() override {}
	// ShareablePointsListIOLexer
	virtual bool startLexer(int start, int end) override;
	virtual void initLexer() override;
	virtual void endLexer() override;

	// LexerParser
	/** @return the symbol of the rule starting at index 1 */
	QStringRef &sym(int index) { return _stack[_tos + index - 1].parsed; }
	/**
	 * @return the parsed token.
	 * This method is called automatically by parse() and shouldn't be touched. It will automatically call your implementation of nextToken(QStringRef).
	 *
	 * This function takes care of handling new lines, comments and whitespaces.
	 */
	State nextToken();
	/** Set the characters that can start a comment */
	void commentChars(QString chars) noexcept { _commentChars = std::move(chars); }
	/** Get the characters that can start a comment */
	const QString &commentChars() const noexcept { return _commentChars; }
	/**
	 * Add the given style to `sym(idx)`.
	 * It litteraly calls `addStyleSym(style, sym(idx);`.
	 *
	 * @param style the style to apply
	 * @param idx the index in sym()
	 */
	void addStyleSym(int style, int idx = 1) { addStyleSym(style, sym(idx)); }
	/**
	 * Add the given style to the provided symbol (`tostyle`).
	 * If part of the line before `sym(idx)` hasn't been styled, it will automatically style it to `0` (Default).
	 * If part of the line has already been styled, it will replace the styles with the parameters.
	 *
	 * @param style the style to apply
	 * @param tostyle the symbol to style
	 */
	void addStyleSym(int style, const QStringRef tostyle);
	/**
	 * Insert indicator to `sym(idx)`.
	 * @param indicatorType the indicator ID (generally a IndicatorType)
	 * @param idx the index in sym()
	 * @param value the value for this indication. In case of IndicatorType::InnerIndic, the value is the position we will jump to on click
	 */
	void addIndicationSym(int indicatorType, int idx = 1, int value = -1);
	/**
	 * Call parse() on the given contents.
	 * Unlike styleText(int, int), this method parses the given contents, not the content of the editor.
	 *
	 * This can be useful when you want to use the the class not as a lexer but as a deserializer.
	 */
	virtual void parseString(const std::string &contents);

protected:
	/** Set of inline contexts. Automatically cleared at end of line. */
	std::unordered_set<int> _inlineContexts;
	/** Stack of contexts */
	std::vector<int> _contexts;
	/** updated each time we meet a comment */
	QString _unusedComment;

private:
	// LexerParser
	/**
	 * Should return one the the token defined in the grammar.
	 *
	 * @param value the parsed value. It may include whitespaces before and/or after (so we store them in sym() and we can style all of it)
	 * @return the parsed token
	 */
	virtual int nextToken(QStringRef value) = 0;
	/**
	 * Function automatically called during the parsing to execute any piece of code associated to a rule.
	 * The function should look like this:
	 * @code{cpp}
	 void Example::consumeRule(int rule)
	{
		switch (rule)
		{
			. /

	----------------------------------------------------------- RULES

	Start: Expressions EOL; -- must finish by one or more end of line

	EOL: EOL_SYMBOL
		| EOL EOL_SYMBOL;

	Expressions: Expression
		| Expressions Expression
		| Expressions Expression;

	Expression: INTEGER
	/.
		case $rule_number:
			addStyleSym(Styles::Integer, 1);
			_result = sym(1);
			break;
	./
		| INTEGER PLUS INTEGER
	/.
		case $rule_number:
			addStyleSym(Styles::Integer, 1);
			addStyleSym(Styles::Sign, 2);
			addStyleSym(Styles::Integer, 3);
			_result = sym(1) + sym(3);
			break;
	./
		| INTEGER MINUS INTEGER;
	/.
		case $rule_number:
			addStyleSym(Styles::Integer, 1);
			addStyleSym(Styles::Sign, 2);
			addStyleSym(Styles::Integer, 3);
			_result = sym(1) - sym(3);
			break;
	./

	----------------------------------------------------------- ENDRULES

	/.
		} // of the switch
	}
	 * @endcode
	 */
	virtual void consumeRule(int rule) = 0;

	bool isWordSeparator(QChar ch) const noexcept;

private:
	struct _ParseStack
	{
		int state = 0;
		QStringRef parsed;
	};
	std::vector<_ParseStack> _stack;
	/** current top of the stack */
	size_t _tos = 0;
	/** current position in the current line */
	int _curpostoken = -1;
	/** list of characters that can start a comment */
	QString _commentChars;
};

/**
 * Return a formatted error: wrong token and expected tokens.
 *
 * @param got the token that we got
 * @param expected the expected tokens
 * @param html if we should write the error in the HTML format (or txt)
 * @return the formatted error
 */
SUGL_SHARED_EXPORT QString writeError(const QString &got, const QStringList &expected, bool html = false);
/**
 * Return the error encountered, and the expected tokens.
 *
 * @param badState the bad state with the bad token, its representation (parsed) and the act that lead here
 * @param terminal_count the number of terminals: `_Table::TERMINAL_COUNT`
 * @param eof_symbole the value of the eof_symbol: `_Table::EOF_SYMBOL`
 * @param spell the spell table: `_Table::spell`
 * @param t_action the t_action function: `&_Table::t_action` (we use a bare function pointer to avoid including <functional>)
 * @param html if the error should be formatted in HTML or in plain text
 *
 * @return the formatted error
 */
SUGL_SHARED_EXPORT QString _writeError(State badState, int terminal_count, int eof_symbol, const char *const spell[], int (*t_action)(int, int), bool html = false);
/** helper function to avoid including <Qsci/qsciscintilla.h> */
SUGL_SHARED_EXPORT void _deleteMarkers(QsciScintilla *editor, int marker = -1);
/** helper function to avoid including <Qsci/qsciscintilla.h> */
SUGL_SHARED_EXPORT int _textLength(const QsciScintilla *editor);
/** helper function to avoid including <Qsci/qsciscintilla.h> */
SUGL_SHARED_EXPORT bool _isEditorUtf8(const QsciScintilla *editor);

/**
 * Exception that can happen during parsing.
 * This should mainly be used in the function LexerParser::consumeRule() in case a value is wrong.
 */
class SUGL_SHARED_EXPORT ParserException : public std::exception
{
public:
	ParserException() = default;
	ParserException(QString got, QStringList expected) :
		_got(std::move(got)), _expected(std::move(expected)), _error(toByteArray(writeError(_got, _expected), true).constData())
	{
	}
	virtual ~ParserException() override = default;

	virtual const char *what() const noexcept override { return _error.c_str(); }
	QString error(bool html = false) const noexcept { return writeError(_got, _expected, html); }

private:
	const QString _got;
	const QStringList _expected;
	const std::string _error;
};

/* ****************** *
 *   IMPLEMENTATION   *
 * ****************** */

template<class _Table>
inline void LexerParser<_Table>::styleText(int start, int end)
{
	// StyleText just for part of contents is impossible for QLALR grammar.
	// Therefore, styling is applied only for the entire text and for optimization reasons it is mainly called after no editing was performed for some time.
	// Lastly, that is why `styleText` or `updateContent` has to be called explicitly for classes using `LexerParser` lexers, either on character change or whenever it is suitable.
	if (start != 0 || end != _textLength(editor()))
		return;

	if (startLexer(start, end))
	{
		parse();
		applyStyles();
	}
	endLexer();
}

template<class _Table>
void LexerParser<_Table>::parse()
{
	_stack[++_tos].state = 0;
	State state{}, lastgoodstate{};
	QStringRef text = &_currentText; // copy of current text
	int endline = 0, startline = 0, prevact = 0;

	while (true)
	{
		// get new token
		if (state.token == -1 && (-_Table::TERMINAL_COUNT != _Table::action_index[state.act]))
		{
			// line management
			if (_curpostoken >= _currentLine.size())
			{
				_curpostoken = 0;
				lastgoodstate = state;
				// finish current line
				if (_styles.getEndline() > 0)
					addStyle(_styles.getEndline(), 0); // 0 is default style
				annotate(startline, _errorAnnotation + _infoAnnotation);
				foldLine(startline, _currentLine.trimmed().isEmpty());
				// set up new line
				text = text.right(text.size() - endline);
				endline = text.indexOf('\n');
				endline = (endline >= 0) ? endline + 1 : text.size();
				_currentLine = text.left(endline);
				_styles.addLine(editor() && _isEditorUtf8(editor()) ? _currentLine.toUtf8().size() : endline);
				startline = _curpos;
				// get (previous) annotations
				_infoAnnotation = annotation(_curpos);
				_errorAnnotation.clear();
			}

			const auto &tmp = nextToken();
			state.token = std::move(tmp.token);
			state.parsed = std::move(tmp.parsed);
		}

		prevact = state.act;
		state.act = _Table::t_action(state.act, state.token);

		// end of rule
		if (_stack[_tos].state == _Table::ACCEPT_STATE)
			break;
		// need next token
		else if (state.act > 0)
		{
			_tos++;
			if (_tos == _stack.size())
				_stack.resize(_tos * 2);
			_stack[_tos].parsed = state.parsed;
			_stack[_tos].state = state.act;
			state.token = -1;
		}
		// production complete, need to parse
		else if (state.act < 0)
		{
			const int r = -state.act - 1;
			_tos = _Table::rhs[r] > (size_t)_tos ? 0 : _tos - _Table::rhs[r];
			state.act = _stack[_tos++].state;
			try
			{
				consumeRule(r);
			}
			catch (const ParserException &e)
			{
				if (!editor())
					throw SPIOException(e.what(), "", toByteArray(state.parsed.toString(), utf8()).constData());

				QString error = e.error(true);
				if (!_infoAnnotation.contains(error))
					_errorAnnotation += std::move(error);
				if (_lexerMode)
					addMarker(editor(), startline, TextMarker::ERROR);
			}
			state.act = _stack[_tos].state = _Table::nt_action(state.act, _Table::lhs[r] - _Table::TERMINAL_COUNT);
		}
		// error handling
		else
		{
			QString error = _writeError({prevact, state.token, state.parsed}, _Table::TERMINAL_COUNT, _Table::EOF_SYMBOL, _Table::spell, &_Table::t_action, editor());
			if (!editor())
				throw SPIOException(toByteArray(error, utf8()).constData(), "", toByteArray(state.parsed.toString(), utf8()).constData());

			if (!_infoAnnotation.contains(error))
				_errorAnnotation += std::move(error);
			if (_lexerMode)
				addMarker(editor(), startline, TextMarker::ERROR);

			if (state.token == _Table::EOF_SYMBOL)
				break;
			state = lastgoodstate;
		}
	}
	// finish last line
	if (_styles.getEndline() > 0)
		addStyle(_styles.getEndline(), 0); // 0 is default style
	annotate(startline, _errorAnnotation + _infoAnnotation);
}

template<class _Table>
inline bool LexerParser<_Table>::startLexer(int, int)
{
	if (!editor())
		return false;

	// trick to always analyse the whole text
	// if we see that analyse become too slow, we can try to improve the lexer here
	// this is needed to keep the sets of active and passive points up to date
	return ShareablePointsListIOLexer::startLexer(0, _textLength(editor()));
}

template<class _Table>
inline void LexerParser<_Table>::initLexer()
{
	ShareablePointsListIOLexer::initLexer();

	_inlineContexts.clear();
	_contexts.clear();
	_unusedComment.clear();
	_stack.clear();
	_stack.resize(32);
	_tos = 0;
	_curpostoken = 0;
}

template<class _Table>
inline void LexerParser<_Table>::endLexer()
{
	ShareablePointsListIOLexer::endLexer();

	_inlineContexts.clear();
	_contexts.clear();
	_unusedComment.clear();
	_stack.clear();
	_tos = 0;
	_curpostoken = -1;
}

template<class _Table>
State LexerParser<_Table>::nextToken()
{
	if (_curpostoken < 0 || _curpostoken >= _currentLine.size())
		return {0, _Table::EOF_SYMBOL, {}};

	enum class CharType
	{
		WHITESPACE,
		WHITESPACE_AFTER_CHAR,
		WORDCHAR,
		NONWORDCHAR
	};
	CharType chartype = CharType::WHITESPACE;

	if (_currentLine[_curpostoken] == '\n')
	{
		_inlineContexts.clear();
		_curpostoken++;
		return {0, _Table::EOL_SYMBOL, _currentLine.mid(_curpostoken - 1, 1)};
	}
	// we extract the characters
	int ch;
	for (ch = _curpostoken; ch < _currentLine.size(); ch++)
	{
		const QChar &currentChar = _currentLine[ch];

		// whitespaces
		if (currentChar.isSpace())
		{
			if (currentChar == '\n')
				break;
			if (chartype != CharType::WHITESPACE)
				chartype = CharType::WHITESPACE_AFTER_CHAR;
			continue;
		}

		// we had chars, then whitespaces, and now chars again
		if (chartype == CharType::WHITESPACE_AFTER_CHAR)
			break;

		// word separator character
		if (chartype == CharType::NONWORDCHAR)
			break;
		if (isWordSeparator(currentChar))
		{
			if (chartype != CharType::WHITESPACE)
				break;
			chartype = CharType::NONWORDCHAR;
			continue;
		}

		// comments
		if (chartype == CharType::WHITESPACE && _commentChars.contains(currentChar))
		{
			int chtmp = _currentLine[_currentLine.size() - 1] == '\n' ? _currentLine.size() - 1 : _currentLine.size();
			if (_curpostoken == 0)
			{
				if (!_unusedComment.isEmpty())
					_unusedComment += '\n';
				_unusedComment += _currentLine.mid(ch + 1, chtmp - ch - 1).toString();
			}
			ch = chtmp;
			break;
		}

		// continue normally
		chartype = CharType::WORDCHAR;
	}

	QStringRef tokenparsed = _currentLine.mid(_curpostoken, ch - _curpostoken);
	// only white spaces
	if (tokenparsed.trimmed().isEmpty())
	{
		_curpostoken = ch;
		return nextToken();
	}
	// we ask for the token corresponding to the given string
	const int token = nextToken(tokenparsed);
	_curpostoken = ch;
	return {0, token, tokenparsed};
}

template<class _Table>
void LexerParser<_Table>::addStyleSym(int style, const QStringRef tostyle)
{
	if (!_lexerMode)
		return;

	if (tostyle.position() - unstyledLine().position() >= 0 || _styles.lastLine().empty()) // we append
	{
		// if beginning of the line is not styled
		if (tostyle.position() != unstyledLine().position())
			addStyle(tostyle.position() - unstyledLine().position(), 0);
		addStyle(tostyle.size(), style);
		return;
	}

	// we need to replace in the middle
	const int position = tostyle.position() - _currentLine.position();
	auto &styles = _styles.lastLine();
	auto i = std::begin(styles);
	int posbeg = i->first;
	// find start insertion position
	while (i != std::end(styles) && position >= posbeg)
	{
		i++;
		posbeg += i->first;
	}
	if (position == posbeg - i->first && tostyle.size() == i->first) // we simply replace
	{
		i->second = style;
		return;
	}
	// find end insertion position
	int posend = posbeg;
	auto j = i;
	while (j != std::end(styles) && position + tostyle.size() > posend)
	{
		j++;
		if (j != std::end(styles))
			posend += j->first;
	}
	bool overflow = j == std::end(styles);

	// insert style
	// total covering
	if (position == posbeg - i->first && (overflow || position + tostyle.size() == posend))
	{
		if (!overflow)
			j++;
		auto newit = i;
		newit++;
		styles.erase(newit, j);
		i->first = tostyle.size();
		i->second = style;
		return;
	}
	// first remove all overridden styles
	if (i != j)
	{
		auto newit = i;
		newit++;
		styles.erase(newit, j);
	}

	// easy cases
	// overflow
	if (overflow)
	{
		i->first = position - posbeg + i->first;
		styles.emplace(std::end(styles), tostyle.size(), style);
		return;
	}
	const auto savej = *j; // copy in case i = j and we change *i (and *j in the same time)
	// partial covering left
	if (position == posbeg - i->first)
	{
		i->first = tostyle.size();
		i->second = style;
		if (i != j)
			j->first = posend - position - tostyle.size();
		else // inner insertion
		{
			i++;
			styles.emplace(i, posend - position - tostyle.size(), savej.second);
		}
		return;
	}
	// partial covering right
	if (position + tostyle.size() == posend)
	{
		if (i != j)
			i->first = position - posbeg + i->first;
		else // inner insertion
			styles.emplace(i, position - posbeg + i->first, savej.second);
		j->first = tostyle.size();
		j->second = style;
		return;
	}

	// complex case, we squeeze i
	i->first = position - posbeg + i->first;
	// we insert
	auto newit = i;
	newit++;
	newit = styles.emplace(newit, tostyle.size(), style);
	// we squeeze j
	if (i == j)
	{
		newit++;
		styles.emplace(newit, posend - position - tostyle.size(), savej.second);
	}
	else
	{
		j->first = posend - position - tostyle.size();
		j->first = posend - position - tostyle.size();
		j->second = savej.second;
	}
}

template<class _Table>
inline void LexerParser<_Table>::addIndicationSym(int indicatorType, int idx, int value)
{
	if (_lexerMode)
	{
		QStringRef tmp = sym(idx).trimmed();
		addIndication(editor(), indicatorType, tmp.position(), tmp.size(), value);
	}
}

template<class _Table>
inline void LexerParser<_Table>::parseString(const std::string &contents)
{
	_currentText = fromByteArray(contents.c_str(), utf8());
	initLexer();
	parse();
	endLexer();
}

template<class _Table>
inline bool LexerParser<_Table>::isWordSeparator(QChar ch) const noexcept
{
	if (ch.isLetter() || ch.isSpace())
		return false;
	QString validChars = wordCharacters();
	return !validChars.contains(ch) && !commentChars().contains(ch);
}

#endif // LEXERPARSER_HPP
